<?php
/**
 * Testimonial widget
 */

class accelerate_testimonial_widget extends WP_Widget {

	function __construct() {
		$widget_ops  = array(
			'classname'   => 'widget_testimonial',
			'description' => __( 'Display Testimonial', 'accelerate' ),
		);
		$control_ops = array( 'width' => 200, 'height' => 250 );
		parent::__construct( false, $name = __( 'TG: Testimonial', 'accelerate' ), $widget_ops, $control_ops );
	}

	function widget( $args, $instance ) {
		extract( $args );

		$title   = apply_filters( 'widget_title', empty( $instance['title'] ) ? '' : $instance['title'], $instance, $this->id_base );
		$text1   = apply_filters( 'widget_text', empty( $instance['text1'] ) ? '' : $instance['text1'], $instance );
		$name1   = apply_filters( 'widget_name', empty( $instance['name1'] ) ? '' : $instance['name1'], $instance, $this->id_base );
		$byline1 = apply_filters( 'widget_byline', empty( $instance['byline1'] ) ? '' : $instance['byline1'], $instance, $this->id_base );
		$image1  = isset( $instance['image1'] ) ? $instance['image1'] : '';

		$text2   = apply_filters( 'widget_text', empty( $instance['text2'] ) ? '' : $instance['text2'], $instance );
		$name2   = apply_filters( 'widget_name', empty( $instance['name2'] ) ? '' : $instance['name2'], $instance, $this->id_base );
		$byline2 = apply_filters( 'widget_byline', empty( $instance['byline2'] ) ? '' : $instance['byline2'], $instance, $this->id_base );
		$image2  = isset( $instance['image2'] ) ? $instance['image2'] : '';

		// For WPML plugin compatibility
		if ( function_exists( 'icl_register_string' ) ) {
			icl_register_string( 'Accelerate Pro', 'TG: First Testimonial widget text' . $this->id, $text1 );
			icl_register_string( 'Accelerate Pro', 'TG: First Testimonial widget name' . $this->id, $name1 );
			icl_register_string( 'Accelerate Pro', 'TG: First Testimonial widget byline' . $this->id, $byline1 );
			icl_register_string( 'Accelerate Pro', 'TG: First Testimonial widget image one' . $this->id, $image1 );

			icl_register_string( 'Accelerate Pro', 'TG: Second Testimonial widget text' . $this->id, $text2 );
			icl_register_string( 'Accelerate Pro', 'TG: Second Testimonial widget name' . $this->id, $name2 );
			icl_register_string( 'Accelerate Pro', 'TG: Second Testimonial widget byline' . $this->id, $byline2 );
			icl_register_string( 'Accelerate Pro', 'TG: Second Testimonial widget image two' . $this->id, $image2 );
		}

		echo $before_widget;
		if ( ! empty( $title ) ) {
			echo $before_title . esc_html( $title ) . $after_title;
		} ?>
		<div class="first-testimonial">
			<?php if ( ! empty( $text1 ) ) { ?>
				<div class="testimonial-post"><i class="fa fa-quote-left"></i>
					<?php
					// For WPML plugin compatibility
					if ( function_exists( 'icl_t' ) ) {
						$text1 = icl_t( 'Accelerate Pro', 'TG: First Testimonial widget text' . $this->id, $text1 );
					}
					echo '<p>' . esc_textarea( $text1 ) . '</p>'; ?></div>
			<?php } ?>
			<div class="testimonial-author">
				<div class="testimonial-author-detail">
					<span><?php
						// For WPML plugin compatibility
						if ( function_exists( 'icl_t' ) ) {
							$name1 = icl_t( 'Accelerate Pro', 'TG: First Testimonial widget name' . $this->id, $name1 );
						}
						echo esc_html( $name1 ); ?></span><br />
					<?php
					// For WPML plugin compatibility
					if ( function_exists( 'icl_t' ) ) {
						$byline1 = icl_t( 'Accelerate Pro', 'TG: First Testimonial widget byline' . $this->id, $byline1 );
					}
					echo esc_html( $byline1 ); ?>
				</div>
				<?php if ( ! empty( $image1 ) ) {
					// For WPML plugin compatibility
					if ( function_exists( 'icl_t' ) ) {
						$image1 = icl_t( 'Accelerate Pro', 'TG: First Testimonial widget image one' . $this->id, $image1 );
					}
					?>
					<div class="testimonial-author-image">
						<img src="<?php echo $image1; ?>" alt="<?php echo $name1; ?>">
					</div>
				<?php } ?>
			</div>
		</div>
		<div class="second-testimonial">
			<?php if ( ! empty( $text2 ) ) { ?>
				<div class="testimonial-post"><i class="fa fa-quote-left"></i>
					<?php
					// For WPML plugin compatibility
					if ( function_exists( 'icl_t' ) ) {
						$text2 = icl_t( 'Accelerate Pro', 'TG: Second Testimonial widget text' . $this->id, $text2 );
					}
					echo '<p>' . esc_textarea( $text2 ) . '</p>'; ?></div>
			<?php } ?>
			<div class="testimonial-author">
				<div class="testimonial-author-detail">
					<span><?php
						// For WPML plugin compatibility
						if ( function_exists( 'icl_t' ) ) {
							$name2 = icl_t( 'Accelerate Pro', 'TG: Second Testimonial widget name' . $this->id, $name2 );
						}
						echo esc_html( $name2 ); ?></span><br />
					<?php
					// For WPML plugin compatibility
					if ( function_exists( 'icl_t' ) ) {
						$byline2 = icl_t( 'Accelerate Pro', 'TG: Second Testimonial widget byline' . $this->id, $byline2 );
					}
					echo esc_html( $byline2 ); ?>
				</div>
				<?php if ( ! empty( $image2 ) ) {
					// For WPML plugin compatibility
					if ( function_exists( 'icl_t' ) ) {
						$image2 = icl_t( 'Accelerate Pro', 'TG: Second Testimonial widget image two' . $this->id, $image2 );
					}
					?>
					<div class="testimonial-author-image">
						<img src="<?php echo $image2; ?>" alt="<?php echo $name2; ?>">
					</div>
				<?php } ?>
			</div>
		</div>
		<?php
		echo $after_widget;
	}

	function update( $new_instance, $old_instance ) {
		$instance = $old_instance;

		$instance['title'] = strip_tags( $new_instance['title'] );

		$instance['name1']   = strip_tags( $new_instance['name1'] );
		$instance['byline1'] = strip_tags( $new_instance['byline1'] );
		if ( current_user_can( 'unfiltered_html' ) ) {
			$instance['text1'] = $new_instance['text1'];
		} else {
			$instance['text1'] = stripslashes( wp_filter_post_kses( addslashes( $new_instance['text1'] ) ) );
		} // wp_filter_post_kses() expects slashed
		$instance['image1'] = esc_url_raw( $new_instance['image1'] );

		$instance['name2']   = strip_tags( $new_instance['name2'] );
		$instance['byline2'] = strip_tags( $new_instance['byline2'] );
		if ( current_user_can( 'unfiltered_html' ) ) {
			$instance['text2'] = $new_instance['text2'];
		} else {
			$instance['text2'] = stripslashes( wp_filter_post_kses( addslashes( $new_instance['text2'] ) ) );
		} // wp_filter_post_kses() expects slashed
		$instance['image2'] = esc_url_raw( $new_instance['image2'] );

		return $instance;
	}

	function form( $instance ) {
		$instance = wp_parse_args( (array) $instance, array(
			'title'   => '',
			'text1'   => '',
			'name1'   => '',
			'byline1' => '',
			'image1'  => '',
			'text2'   => '',
			'name2'   => '',
			'byline2' => '',
			'image2'  => '',
		) );
		$title    = strip_tags( $instance['title'] );
		$name1    = strip_tags( $instance['name1'] );
		$byline1  = strip_tags( $instance['byline1'] );
		$text1    = esc_textarea( $instance['text1'] );
		$image1   = esc_url( $instance['image1'] );
		$name2    = strip_tags( $instance['name2'] );
		$byline2  = strip_tags( $instance['byline2'] );
		$text2    = esc_textarea( $instance['text2'] );
		$image2   = esc_url( $instance['image2'] );
		?>
		<p><?php _e( 'Note: To add the image. Go to Media->Add New. Upload an image. Copy the image path link and paste in image input field. Recommended size for the image is 72 x 72 pixels.', 'accelerate' ); ?></p>
		<p>
		<p><label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e( 'Title:', 'accelerate' ); ?></label>
			<input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo esc_attr( $title ); ?>" />
		</p>

		<strong><?php _e( 'First Testimonial', 'accelerate' ); ?></strong><br />
		<?php _e( 'Testimonial Description', 'accelerate' ); ?>
		<textarea class="widefat" rows="8" cols="20" id="<?php echo $this->get_field_id( 'text1' ); ?>" name="<?php echo $this->get_field_name( 'text1' ); ?>"><?php echo $text1; ?></textarea>

		<p><label for="<?php echo $this->get_field_id( 'name1' ); ?>"><?php _e( 'Name:', 'accelerate' ); ?></label>
			<input class="widefat" id="<?php echo $this->get_field_id( 'name1' ); ?>" name="<?php echo $this->get_field_name( 'name1' ); ?>" type="text" value="<?php echo esc_attr( $name1 ); ?>" />
		</p>

		<p><label for="<?php echo $this->get_field_id( 'byline1' ); ?>"><?php _e( 'Byline:', 'accelerate' ); ?></label>
			<input class="widefat" id="<?php echo $this->get_field_id( 'byline1' ); ?>" name="<?php echo $this->get_field_name( 'byline1' ); ?>" type="text" value="<?php echo esc_attr( $byline1 ); ?>" />
		</p>
		<p>
			<label for="<?php echo $this->get_field_id( 'image1' ); ?>"><?php _e( 'Image:', 'accelerate' ); ?></label>
			<input style="width:100%;" id="<?php echo $this->get_field_id( 'image1' ); ?>" name="<?php echo $this->get_field_name( 'image1' ); ?>" type="text" value="<?php echo $image1; ?>" />
		</p>

		<strong><?php _e( 'Second Testimonial', 'accelerate' ); ?></strong><br />
		<?php _e( 'Testimonial Description', 'accelerate' ); ?>
		<textarea class="widefat" rows="8" cols="20" id="<?php echo $this->get_field_id( 'text2' ); ?>" name="<?php echo $this->get_field_name( 'text2' ); ?>"><?php echo $text2; ?></textarea>

		<p><label for="<?php echo $this->get_field_id( 'name2' ); ?>"><?php _e( 'Name:', 'accelerate' ); ?></label>
			<input class="widefat" id="<?php echo $this->get_field_id( 'name2' ); ?>" name="<?php echo $this->get_field_name( 'name2' ); ?>" type="text" value="<?php echo esc_attr( $name2 ); ?>" />
		</p>

		<p><label for="<?php echo $this->get_field_id( 'byline2' ); ?>"><?php _e( 'Byline:', 'accelerate' ); ?></label>
			<input class="widefat" id="<?php echo $this->get_field_id( 'byline2' ); ?>" name="<?php echo $this->get_field_name( 'byline2' ); ?>" type="text" value="<?php echo esc_attr( $byline2 ); ?>" />
		</p>
		<p>
			<label for="<?php echo $this->get_field_id( 'image2' ); ?>"><?php _e( 'Image:', 'accelerate' ); ?></label>
			<input style="width:100%;" id="<?php echo $this->get_field_id( 'image2' ); ?>" name="<?php echo $this->get_field_name( 'image2' ); ?>" type="text" value="<?php echo $image2; ?>" />
		</p>

		<?php
	}
}
